; ADXL345Cu[  Version 1.00
; File:        adxl345.asm
; Target:      PIC18F14K50 48Mhz
; AZu:   Microchip MPASM(v5.51)
; :     PICKit 3
; [X:     2013/10/01 21:00

        #DEFINE ADXL345_ASM 1

        #INCLUDE <p18f14k50.inc>
        #INCLUDE "i2c.inc"
        #INCLUDE "adxl345.inc"

        EXTERN ARGH,ARGL,GX,GY,GZ
        GLOBAL adxl345_single_write
        GLOBAL adxl345_single_read
        GLOBAL adxl345_gread_xyz
        GLOBAL adxl345_init

        CODE

adxl345_init
        movlw   b'00001011'  ; }2g ő啪\
        movwf   ARGL
        movlw   ADXL345_DATA_FORMAT
        movwf   ARGH
        rcall   adxl345_single_write

        movlw   b'00001000'  ; 胂[h Measure
        movwf   ARGL
        movlw   ADXL345_POWER_CTL
        movwf   ARGH
        rcall   adxl345_single_write

        movlw   b'00000111'  ; TvOg 12.5Hz
        movwf   ARGL
        movlw   ADXL345_BW_RATE
        movwf   ARGH
        rcall   adxl345_single_write
        return

adxl345_single_write    ;   ARGH:WX^AhX ARGL:Cgf[^
        rcall   i2c_start   ; X^[go
        movlw   ADXL345_SADS ; X[uAhX
        rcall   i2c_write
        movf    ARGH,W
        rcall   i2c_write
        movf    ARGL,W
        rcall   i2c_write
        rcall   i2c_stop
        return

adxl345_single_read    ; ARGH:WX^AhX WREG:[hf[^
        rcall   i2c_start
        movlw   ADXL345_SADS
        rcall   i2c_write
        movf    ARGH,W
        rcall   i2c_write

        rcall   i2c_restart
        movlw   ADXL345_SADS+1
        rcall   i2c_write

        rcall   i2c_last_read
        rcall   i2c_stop
        return

adxl345_gread_xyz    ; ADXL345 xyzxɌĂяo
        rcall   i2c_start
        movlw   ADXL345_SADS
        rcall   i2c_write
        movlw   ADXL345_DATAX
        rcall   i2c_write

        rcall   i2c_restart
        movlw   ADXL345_SADS+1
        rcall   i2c_write

        lfsr    FSR1,GX
        movlw   6
        rcall   i2c_block_read
        return

        END



