; ADXL345gpx\  Version 1.00
; File:        g1a.asm
; Target:      PIC18F14K50 48Mhz
; AZu:   Microchip MPASM(v5.51)
; :     PICKit 3
; [X:     2013/10/01 21:00


        #INCLUDE <p18f14k50.inc>
        #INCLUDE "lcd.inc"
        #INCLUDE "stdlib.inc"
        #INCLUDE "i2c.inc"
        #INCLUDE "adxl345.inc"

        ; U(12MHz) NbN PLLL(*4)
        ; EHb`hbO^C} dvO݃[h
        CONFIG FOSC = HS,CPUDIV = NOCLKDIV,PLLEN=ON,WDTEN=OFF,LVP=OFF

;   vOads̃AhXTLPTRWX^ɏ㏑

LDTBLPTR MACRO ads
        movlw   UPPER ads
        movwf   TBLPTRU
        movlw   HIGH ads
        movwf   TBLPTRH
        movlw   LOW ads
        movwf   TBLPTRL
        ENDM

bank0        UDATA   ; ϐ̒` oN0@ANZXoN
Tcount1     RES 1      ; wait
Tcount2     RES 1      ; wait
Tcount3     RES 1      ; wait
LCD_WRITE   RES 1      ; writef[^w
LCD_TEMP    RES 1
Temp1       RES 1      ; Tu[`p̕ϐ
ARG1        RES 1      ; Tu[`
BYTE2HEX_TEMP RES 1

DIV_A       RES 1 ; Z̔폜w@Tu[`R[㓚Ԃ
DIV_MOD     RES 1 ; Tu[`R[]肪Ԃ
DIV_B       RES 1 ; Z̏w
DIV_AL      RES 1
DIV_AH      RES 1
DIV_MODL    RES 1
DIV_MODH    RES 1
DIV_COUNT   RES 1

LCD_BUF     RES 32     ; 16*2̃obt@
ARGL        RES 1
ARGH        RES 1

GX          RES 2   ; xx
GY          RES 2   ; xy
GZ          RES 2   ; xz

        GLOBAL  LCD_WRITE,LCD_TEMP,ARG1,ARGL,ARGH
        GLOBAL  Temp1,BYTE2HEX_TEMP
        GLOBAL  DIV_A,DIV_MOD,DIV_B,DIV_AL,DIV_AH,DIV_MODL,DIV_MODH,DIV_COUNT
        GLOBAL  Tcount1,Tcount2,Tcount3
        GLOBAL  GX,GY,GZ

        CODE
        ORG 0
        goto   start    ;   Zbg

start
        clrf    ANSEL   ; RC3-RC0,RA4fW^̓obt@ɐݒ
        clrf    ANSELH  ; RB5-RB4,RC7-RC6fW^̓obt@ɐݒ
        clrf    SLRCON  ; PORTA,PORTB,PORTCX[[gWɐݒ
        clrf    TRISA   ; PORTASo͂ɐݒ
        movlw   0f0h
        movwf   TRISB   ; RB7-RB4͂ɐݒ
        clrf    TRISC   ; PORTCSo͂ɐݒ肷
        clrf    PORTC   ; PORTCS0ɂB

        movlw   b'00101000' ; SSPW[on,I2C}X^[[h
        movwf   SSPCON1
        clrf    SSPCON2

        movlw   d'116'    ; 100kbps
        movwf   SSPADD
        clrf    SSPSTAT

        rcall   lcd_init    ;   t

        LDTBLPTR lcd_init_str ; }NTBLPTRWX^lcd_init_strݒ
        movlw   d'32'
        lfsr    FSR0,LCD_BUF

        rcall   prog2mem

        rcall   adxl345_init
loops
        rcall   adxl345_gread_xyz

        movf    GX,W
        movwf   ARGL
        movf    GX+1,W
        movwf   ARGH
        lfsr    FSR1,LCD_BUF+2
        rcall   word2sdeg

        movf    GY,W
        movwf   ARGL
        movf    GY+1,W
        movwf   ARGH
        lfsr    FSR1,LCD_BUF+d'10'
        rcall   word2sdeg

        movf    GZ,W
        movwf   ARGL
        movf    GZ+1,W
        movwf   ARGH
        lfsr    FSR1,LCD_BUF+d'18'
        rcall   word2sdeg

        lfsr    FSR1,LCD_BUF
        rcall   lcd_disp
        rcall   wait500
        goto    loops

prog2mem    ; vOf[^[փRs[ TABLAT->FSR0
        movwf   Temp1
prog2mem_loop
        tblrd   *+          ;   vOTBLPTRǂݏoTBLPTR+1
        movf    TABLAT,W
        movwf   POSTINC0    ;   ԐڃAhbVO@AhX̓ANZX+1
        decfsz  Temp1       ;   Temp11ʂ0ɂȂ܂ŌJԂ
        bra     prog2mem_loop
        return

wait500                 ; 0.5bWait
        movlw   d'50'  ; 10ms*50=0.5s
        movwf   Tcount1
dloop1
        movlw   d'200'	; 50s*200=10ms
        movwf   Tcount2
dloop2                   ; t=(12+12*count3)/48MHz 50s
        movlw   d'199'
        movwf   Tcount3
        nop
dloop3
        decfsz  Tcount3
        goto    dloop3
        decfsz  Tcount2
        goto    dloop2
        decfsz  Tcount1
        goto    dloop1
        return

lcd_init_str
;                0123456789abcdef
        DB      "X=12345 Y=12345 "
        DB      "Z=12345         "

        END
